﻿using DemoControls;
using LEase;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Demo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        #region Func

        enum WhoseColor { SurroundLineColor, ShrinkColor, SliderColor, TextColor }
        enum WhoseSize { SurroundLineSize, ShrinkSize, DrawMargin, ArcSize, BlockSize }

        void pChangeColor(WhoseColor whoseColor,Color color)
        {
            switch (whoseColor)
            {
                case WhoseColor.SurroundLineColor:
                    lpb_bar.L_SurroundLineColor = color;
                    lpb_arc.L_SurroundLineColor = color;
                    lpb_pie.L_SurroundLineColor = color;
                    break;
                case WhoseColor.ShrinkColor:
                    lpb_bar.L_ShrinkColor = color;
                    lpb_arc.L_ShrinkColor = color;
                    lpb_pie.L_ShrinkColor = color;
                    break;
                case WhoseColor.SliderColor:
                    lpb_bar.L_SliderColor = color;
                    lpb_arc.L_SliderColor = color;
                    lpb_pie.L_SliderColor = color;
                    break;
                case WhoseColor.TextColor:
                    lpb_bar.L_TextColor = color;
                    lpb_arc.L_TextColor = color;
                    lpb_pie.L_TextColor = color;
                    break;
            }
        }

        void pChangeUnknow(MarqueeStyle marqueeStyle)
        {
            lpb_bar.L_ProgressStyle = ProgressStyle.Marquee;
            lpb_arc.L_ProgressStyle = ProgressStyle.Marquee;
            lpb_pie.L_ProgressStyle = ProgressStyle.Marquee;

            lpb_bar.L_MarqueeStyle = marqueeStyle;
            lpb_arc.L_MarqueeStyle = marqueeStyle;
            lpb_pie.L_MarqueeStyle = marqueeStyle;
        }

        void pChangeKnown(ProgressStyle progressStyle)
        {
            lpb_bar.L_ProgressStyle = progressStyle;
            lpb_arc.L_ProgressStyle = progressStyle;
            lpb_pie.L_ProgressStyle = progressStyle;
        }

        void pChangeSize(WhoseSize whoseSize,int size)
        {
            switch (whoseSize)
            {
                case WhoseSize.SurroundLineSize:
                    lpb_bar.L_SurroundLineSize = size;
                    lpb_arc.L_SurroundLineSize = size;
                    lpb_pie.L_SurroundLineSize = size;
                    break;
                case WhoseSize.ShrinkSize:
                    lpb_bar.L_ShrinkSize = size;
                    lpb_arc.L_ShrinkSize = size;
                    lpb_pie.L_ShrinkSize = size;
                    break;
                case WhoseSize.DrawMargin:
                    lpb_bar.L_DrawMargin = size;
                    lpb_arc.L_DrawMargin = size;
                    lpb_pie.L_DrawMargin = size;
                    break;
                case WhoseSize.BlockSize:
                    lpb_bar.L_BlockSize = size;
                    lpb_arc.L_BlockSize = size;
                    lpb_pie.L_BlockSize = size;
                    break;
                case WhoseSize.ArcSize:
                    lpb_bar.L_ArcSize = size;
                    lpb_arc.L_ArcSize = size;
                    lpb_pie.L_ArcSize = size;
                    break;
            }
        }

        #endregion

        private void Form1_Load(object sender, EventArgs e)
        {
            
        }

        
        private void lSBtn_Known_LSwitched(object sender, LEventArgs e)
        {
            if ((bool)e.Value)
            {
                lbl_Unknown.Font = new Font("微软雅黑", 12, FontStyle.Bold | FontStyle.Italic);
                lbl_Known.Font = new Font("微软雅黑", 9);
                groupBox_K.Enabled = false;
                groupBox_UK.Enabled = true;
                groupBox_Text.Enabled = false;
                groupBox_Value.Enabled = false;
                groupBox_wave.Enabled = true;

                lpb_bar.L_ProgressMode = ProgressMode.Unknown;
                lpb_arc.L_ProgressMode = ProgressMode.Unknown;
                lpb_pie.L_ProgressMode = ProgressMode.Unknown;
            }
            else
            {
                lbl_Unknown.Font = new Font("微软雅黑", 9);
                lbl_Known.Font = new Font("微软雅黑", 12, FontStyle.Bold | FontStyle.Italic);
                groupBox_K.Enabled = true;
                groupBox_UK.Enabled = false;
                groupBox_Text.Enabled = true;
                groupBox_Value.Enabled = true;
                groupBox_wave.Enabled = false;

                lsb_wave.L_IsOpen = false;
                lbl_wave.Text ="关";
                lpb_bar.L_StopWave();
                lpb_arc.L_StopWave();
                lpb_pie.L_StopWave();

                lpb_bar.L_ProgressMode = ProgressMode.Known;
                lpb_arc.L_ProgressMode = ProgressMode.Known;
                lpb_pie.L_ProgressMode = ProgressMode.Known;

            }
        }

        #region UnKnown样式
        private void lsb_uk_helical_LSwitched(object sender, LEventArgs e)
        {
            //lsb_uk_helical.L_IsOpen = false;
            lsb_uk_swing.L_IsOpen = false;
            lsb_uk_cross.L_IsOpen = false;
            lsb_uk_rc.L_IsOpen = false;
            lsb_uk_ac.L_IsOpen = false;
            lsb_uk_rb.L_IsOpen = false;
            lsb_uk_ab.L_IsOpen = false;
                        
            lpb_bar.L_ProgressStyle = ProgressStyle.Helical;
            lpb_arc.L_ProgressStyle = ProgressStyle.Helical;
            lpb_pie.L_ProgressStyle = ProgressStyle.Helical;
        }

        private void lsb_uk_swing_LSwitched(object sender, LEventArgs e)
        {
            lsb_uk_helical.L_IsOpen = false;
            //lsb_uk_swing.L_IsOpen = false;
            lsb_uk_cross.L_IsOpen = false;
            lsb_uk_rc.L_IsOpen = false;
            lsb_uk_ac.L_IsOpen = false;
            lsb_uk_rb.L_IsOpen = false;
            lsb_uk_ab.L_IsOpen = false;

            pChangeUnknow(MarqueeStyle.Swing);
        }

        private void lsb_uk_cross_LSwitched(object sender, LEventArgs e)
        {
            lsb_uk_helical.L_IsOpen = false;
            lsb_uk_swing.L_IsOpen = false;
            //lsb_uk_cross.L_IsOpen = false;
            lsb_uk_rc.L_IsOpen = false;
            lsb_uk_ac.L_IsOpen = false;
            lsb_uk_rb.L_IsOpen = false;
            lsb_uk_ab.L_IsOpen = false;

            pChangeUnknow(MarqueeStyle.Cross);
        }

        private void lsb_uk_rc_LSwitched(object sender, LEventArgs e)
        {
            lsb_uk_helical.L_IsOpen = false;
            lsb_uk_swing.L_IsOpen = false;
            lsb_uk_cross.L_IsOpen = false;
            //lsb_uk_rc.L_IsOpen = false;
            lsb_uk_ac.L_IsOpen = false;
            lsb_uk_rb.L_IsOpen = false;
            lsb_uk_ab.L_IsOpen = false;

            pChangeUnknow(MarqueeStyle.Reciprocation_Continuous);
        }

        private void lsb_uk_ac_LSwitched(object sender, LEventArgs e)
        {
            lsb_uk_helical.L_IsOpen = false;
            lsb_uk_swing.L_IsOpen = false;
            lsb_uk_cross.L_IsOpen = false;
            lsb_uk_rc.L_IsOpen = false;
            //lsb_uk_ac.L_IsOpen = false;
            lsb_uk_rb.L_IsOpen = false;
            lsb_uk_ab.L_IsOpen = false;

            pChangeUnknow(MarqueeStyle.Across_Continuous);
        }

        private void lsb_uk_rb_LSwitched(object sender, LEventArgs e)
        {
            lsb_uk_helical.L_IsOpen = false;
            lsb_uk_swing.L_IsOpen = false;
            lsb_uk_cross.L_IsOpen = false;
            lsb_uk_rc.L_IsOpen = false;
            lsb_uk_ac.L_IsOpen = false;
            //lsb_uk_rb.L_IsOpen = false;
            lsb_uk_ab.L_IsOpen = false;

            pChangeUnknow(MarqueeStyle.Reciprocation_Blocks);
        }

        private void lsb_uk_ab_LSwitched(object sender, LEventArgs e)
        {
            lsb_uk_helical.L_IsOpen = false;
            lsb_uk_swing.L_IsOpen = false;
            lsb_uk_cross.L_IsOpen = false;
            lsb_uk_rc.L_IsOpen = false;
            lsb_uk_ac.L_IsOpen = false;
            lsb_uk_rb.L_IsOpen = false;
            //lsb_uk_ab.L_IsOpen = false;

            pChangeUnknow(MarqueeStyle.Across_Blocks);
        }

        #endregion

        #region Known样式
        private void lsb_k_helical_LSwitched(object sender, LEventArgs e)
        {
            //lsb_k_helical.L_IsOpen = false;
            lsb_k_btc.L_IsOpen = false;
            lsb_k_continuous.L_IsOpen = false;
            lsb_k_blocks.L_IsOpen = false;

            pChangeKnown(ProgressStyle.Helical);
        }

        private void lsb_k_btc_LSwitched(object sender, LEventArgs e)
        {
            lsb_k_helical.L_IsOpen = false;
            //lsb_k_btc.L_IsOpen = false;
            lsb_k_continuous.L_IsOpen = false;
            lsb_k_blocks.L_IsOpen = false;

            pChangeKnown(ProgressStyle.BlocksToContinuous);
        }

        private void lsb_k_continuous_LSwitched(object sender, LEventArgs e)
        {
            lsb_k_helical.L_IsOpen = false;
            lsb_k_btc.L_IsOpen = false;
            //lsb_k_continuous.L_IsOpen = false;
            lsb_k_blocks.L_IsOpen = false;

            pChangeKnown(ProgressStyle.Continuous);
        }

        private void lsb_k_blocks_LSwitched(object sender, LEventArgs e)
        {
            lsb_k_helical.L_IsOpen = false;
            lsb_k_btc.L_IsOpen = false;
            lsb_k_continuous.L_IsOpen = false;
            //lsb_k_blocks.L_IsOpen = false;

            pChangeKnown(ProgressStyle.Blocks);
        }

        #endregion

        private void lsb_Text_LSwitched(object sender, LEventArgs e)
        {
            bool b = ((bool)e.Value);
            lbl_Text.Text = b? "显示" : "不显示";

            if (b)
            {
                lpb_bar.L_ProgressText = ProgressText.Percent;
                lpb_arc.L_ProgressText = ProgressText.Percent;
                lpb_pie.L_ProgressText = ProgressText.Percent;
            }
            else
            {
                lpb_bar.L_ProgressText = ProgressText.None;
                lpb_arc.L_ProgressText = ProgressText.None;
                lpb_pie.L_ProgressText = ProgressText.None;
            }
        }

        #region 大小
        private void ltb_surroundlinesize_LValueChanged(object sender, LEventArgs e)
        {
            lbl_surroundlinesize.Text = e.Value.ToString();
            pChangeSize(WhoseSize.SurroundLineSize, (int)e.Value);
        }

        private void ltb_shrinksize_LValueChanged(object sender, LEventArgs e)
        {
            lbl_shrinksize.Text = e.Value.ToString();
            pChangeSize(WhoseSize.ShrinkSize, (int)e.Value);
        }

        private void ltb_drawmargin_LValueChanged(object sender, LEventArgs e)
        {
            lbl_drawmargin.Text = e.Value.ToString();
            pChangeSize(WhoseSize.DrawMargin, (int)e.Value);
        }

        private void ltb_arcsize_LValueChanged(object sender, LEventArgs e)
        {
            lbl_arcsize.Text = e.Value.ToString();
            pChangeSize(WhoseSize.ArcSize, (int)e.Value);
        }

        private void ltb_blocksize_LValueChanged(object sender, LEventArgs e)
        {
            lbl_blocksize.Text = (((int)e.Value)*3).ToString();
            pChangeSize(WhoseSize.BlockSize, ((int)e.Value) * 3);
        }

        #endregion

        #region 颜色
        #region SurroundLineColor
        private void btn_slc_1_Click(object sender, EventArgs e)
        {
            pChangeColor(WhoseColor.SurroundLineColor, Color.Empty);
        }

        private void btn_slc_2_Click(object sender, EventArgs e)
        {
            pChangeColor(WhoseColor.SurroundLineColor, btn_slc_2.BackColor);
        }

        private void btn_slc_3_Click(object sender, EventArgs e)
        {
            pChangeColor(WhoseColor.SurroundLineColor, btn_slc_3.BackColor);
        }

        private void btn_slc_4_Click(object sender, EventArgs e)
        {
            pChangeColor(WhoseColor.SurroundLineColor, btn_slc_4.BackColor);
        }
        #endregion
        #region ShrinkColor
        private void btn_sc_1_Click(object sender, EventArgs e)
        {
            pChangeColor(WhoseColor.ShrinkColor, Color.Empty);
        }

        private void btn_sc_2_Click(object sender, EventArgs e)
        {
            pChangeColor(WhoseColor.ShrinkColor, btn_sc_2.BackColor);
        }

        private void btn_sc_3_Click(object sender, EventArgs e)
        {
            pChangeColor(WhoseColor.ShrinkColor, btn_sc_3.BackColor);
        }

        private void btn_sc_4_Click(object sender, EventArgs e)
        {
            pChangeColor(WhoseColor.ShrinkColor, btn_sc_4.BackColor);
        }
        #endregion
        #region SliderColor
        private void btn_sc2_1_Click(object sender, EventArgs e)
        {
            pChangeColor(WhoseColor.SliderColor, btn_sc2_1.BackColor);
        }

        private void btn_sc2_2_Click(object sender, EventArgs e)
        {
            pChangeColor(WhoseColor.SliderColor, btn_sc2_2.BackColor);
        }

        private void btn_sc2_3_Click(object sender, EventArgs e)
        {
            pChangeColor(WhoseColor.SliderColor, btn_sc2_3.BackColor);
        }

        private void btn_sc2_4_Click(object sender, EventArgs e)
        {
            pChangeColor(WhoseColor.SliderColor, btn_sc2_4.BackColor);
        }
        #endregion
        #region TextColor
        private void btn_tc_1_Click(object sender, EventArgs e)
        {
            pChangeColor(WhoseColor.TextColor, btn_tc_1.BackColor);
        }

        private void btn_tc_2_Click(object sender, EventArgs e)
        {
            pChangeColor(WhoseColor.TextColor, btn_tc_2.BackColor);
        }

        private void btn_tc_3_Click(object sender, EventArgs e)
        {
            pChangeColor(WhoseColor.TextColor, btn_tc_3.BackColor);
        }

        private void btn_tc_4_Click(object sender, EventArgs e)
        {
            pChangeColor(WhoseColor.TextColor, btn_tc_4.BackColor);
        }

        #endregion

        #endregion

        private void ltb_value_LValueChanged(object sender, LEventArgs e)
        {
            lbl_Value.Text = e.Value.ToString();
            lpb_bar.L_Value = (int)e.Value;
            lpb_arc.L_Value = (int)e.Value;
            lpb_pie.L_Value = (int)e.Value;
        }

        private void lsb_wave_LSwitched(object sender, LEventArgs e)
        {
            bool b = (bool)e.Value;
            lbl_wave.Text =  b? "开" : "关";

            if (b)
            {
                lpb_bar.L_StartWave();
                lpb_arc.L_StartWave();
                lpb_pie.L_StartWave();
            }
            else
            {
                lpb_bar.L_StopWave();
                lpb_arc.L_StopWave();
                lpb_pie.L_StopWave();
            }
        }

        private void ltb_height_LValueChanged(object sender, LEventArgs e)
        {
            lpb_arc.Height = lpb_pie.Height = ltb_height.L_Value;
        }

        private void ltb_width_LValueChanged(object sender, LEventArgs e)
        {
            lpb_arc.Width = lpb_pie.Width = ltb_width.L_Value;
        }
    }
}
